use std::sync::atomic::{AtomicU32, Ordering::SeqCst};

use crate::prelude::EntityObject;

#[derive(Default)]
pub struct EntityObjectManager {
    current_entity_id: AtomicU32,
}

impl EntityObjectManager {
    pub(crate) fn fetch_add_entity_id(&self) -> u32 {
        self.current_entity_id.fetch_add(1, SeqCst)
    }

    pub(crate) fn create_entity(&self) -> EntityObject {
        EntityObject::new(self.fetch_add_entity_id())
    }
}
