use engine::prelude::*;

#[derive(Serialize, Deserialize)]
pub struct NPCName {
    pub name: String,
}

impl NPCName {
    pub fn new(name: impl ToString) -> Self {
        Self {
            name: name.to_string(),
        }
    }
}

impl EntityComponent for NPCName {
    fn name(&self) -> &str {
        Self::debug_name()
    }
}

impl ComponentDebug for NPCName {
    fn debug_name() -> &'static str {
        "NPCName"
    }
}
